package com.zhongzheng.modules.exam.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.exam.bo.ExamKnowledgeBusinessAddBo;
import com.zhongzheng.modules.exam.bo.ExamKnowledgeBusinessQueryBo;
import com.zhongzheng.modules.exam.bo.ExamKnowledgeBusinessEditBo;
import com.zhongzheng.modules.exam.domain.ExamKnowledgeBusiness;
import com.zhongzheng.modules.exam.mapper.ExamKnowledgeBusinessMapper;
import com.zhongzheng.modules.exam.vo.ExamKnowledgeBusinessVo;
import com.zhongzheng.modules.exam.service.IExamKnowledgeBusinessService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 知识点Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-19
 */
@Service
public class ExamKnowledgeBusinessServiceImpl extends ServiceImpl<ExamKnowledgeBusinessMapper, ExamKnowledgeBusiness> implements IExamKnowledgeBusinessService {

    @Override
    public ExamKnowledgeBusinessVo queryById(Long id){
        ExamKnowledgeBusiness db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ExamKnowledgeBusinessVo.class);
    }

    @Override
    public List<ExamKnowledgeBusinessVo> queryList(ExamKnowledgeBusinessQueryBo bo) {
        LambdaQueryWrapper<ExamKnowledgeBusiness> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getBusinessId() != null, ExamKnowledgeBusiness::getBusinessId, bo.getBusinessId());
        lqw.eq(bo.getSubjectId() != null, ExamKnowledgeBusiness::getSubjectId, bo.getSubjectId());
        lqw.eq(bo.getKnowledgeId() != null, ExamKnowledgeBusiness::getKnowledgeId, bo.getKnowledgeId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ExamKnowledgeBusinessVo> entity2Vo(Collection<ExamKnowledgeBusiness> collection) {
        List<ExamKnowledgeBusinessVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ExamKnowledgeBusinessVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ExamKnowledgeBusiness> page = (Page<ExamKnowledgeBusiness>)collection;
            Page<ExamKnowledgeBusinessVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ExamKnowledgeBusinessAddBo bo) {
        ExamKnowledgeBusiness add = BeanUtil.toBean(bo, ExamKnowledgeBusiness.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ExamKnowledgeBusinessEditBo bo) {
        ExamKnowledgeBusiness update = BeanUtil.toBean(bo, ExamKnowledgeBusiness.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ExamKnowledgeBusiness entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
